## lfortran 0.58.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10 FATAL_ERROR)

set(CMAKE_USER_MAKE_RULES_OVERRIDE ${CMAKE_SOURCE_DIR}/cmake/UserOverride.cmake)

# We don't execute this if we have a tarball
if (LFORTRAN_BUILD_ALL)
    find_program(RE2C re2c REQUIRED)
    find_program(BISON bison REQUIRED)
    find_program(BASH_BIN bash REQUIRED)
    execute_process(COMMAND "env" "RE2C=${RE2C}" "BISON=${BISON}" "${BASH_BIN}" "-e" "build0.sh" WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} RESULT_VARIABLE _BUILD0_EXIT)
    if (NOT _BUILD0_EXIT EQUAL 0)
        message(FATAL_ERROR "Running build0.sh failed (see error above)")
    endif ()
endif()

file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/version" LFORTRAN_VERSION)
string(REGEX MATCH "^[^-]*" LFORTRAN_NO_TAG_VERSION ${LFORTRAN_VERSION})

project(lfortran
        VERSION ${LFORTRAN_NO_TAG_VERSION}
        DESCRIPTION "A modern open-source interactive Fortran compiler"
        HOMEPAGE_URL "https://lfortran.org/"
        LANGUAGES C CXX)

set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release
        CACHE STRING "Build type (Debug, Release)" FORCE)
endif ()

# xeus does use `dynamic_cast` and thus needs rtti (otherwise it segfaults)
if (NOT WITH_XEUS)
    if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
        set(LFORTRAN_CXX_NO_RTTI_FLAG "-fno-rtti")
    elseif (CMAKE_CXX_COMPILER_ID MATCHES Clang)
        set(LFORTRAN_CXX_NO_RTTI_FLAG "-fno-rtti")
    elseif (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
        set(LFORTRAN_CXX_NO_RTTI_FLAG "/GR-")
    endif ()
endif(NOT WITH_XEUS)

if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /bigobj")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /bigobj")
endif ()

# For CMAKE_INSTALL_BINDIR:
include(GNUInstallDirs)

# create CMAKE_INSTALL_LIBDIR_RELATIVE, LIBDIR relative to BINDIR
file(RELATIVE_PATH CMAKE_INSTALL_LIBDIR_RELATIVE ${CMAKE_INSTALL_FULL_BINDIR} ${CMAKE_INSTALL_FULL_LIBDIR})
# create CMAKE_INSTALL_INCLUDEDIR_RELATIVE, INCLUDEDIR relative to BINDIR
file(RELATIVE_PATH CMAKE_INSTALL_INCLUDEDIR_RELATIVE ${CMAKE_INSTALL_FULL_BINDIR} ${CMAKE_INSTALL_FULL_INCLUDEDIR})

# Build a CPack driven installer package
#
# To build a binary package:
#
# cpack
#
if(NOT WIN32)
    include(InstallRequiredSystemLibraries)
endif()
set(CPACK_GENERATOR "TBZ2")
set(CPACK_STRIP_FILES YES)
set(CPACK_PACKAGE_FILE_NAME lfortran-${LFORTRAN_VERSION}-${CMAKE_SYSTEM_NAME})
include(CPack)
# So that CPACK_PACKAGE_FILE_NAME prints the correct value below
set(CPACK_PACKAGE_FILE_NAME lfortran-${LFORTRAN_VERSION}-${CMAKE_SYSTEM_NAME})


if (NOT CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 17
        CACHE STRING "C++ standard" FORCE)
endif ()

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    # In Debug mode we enable assertions
    set(WITH_LFORTRAN_ASSERT_DEFAULT yes)
else()
    set(WITH_LFORTRAN_ASSERT_DEFAULT no)
endif()


# LFORTRAN_ASSERT
set(WITH_LFORTRAN_ASSERT ${WITH_LFORTRAN_ASSERT_DEFAULT}
    CACHE BOOL "Enable LFORTRAN_ASSERT macro")

# LFORTRAN_STATIC_BIN
set(LFORTRAN_STATIC_BIN no CACHE BOOL "Build LFortran as a static binary")

# WITH_LFORTRAN_BINARY_MODFILES
set(WITH_LFORTRAN_BINARY_MODFILES YES
    CACHE BOOL "Use binary modfiles")

set(WITH_RUNTIME_LIBRARY YES
    CACHE BOOL "Compile and install the runtime library")

set(WITH_WHEREAMI yes
    CACHE BOOL "Include whereami.cpp")

set(WITH_ZLIB yes
    CACHE BOOL "Compile with ZLIB Library")

set(WITH_LCOMPILERS_FAST_ALLOC yes
    CACHE BOOL "Compile with fast allocator")

set(WITH_CCACHE no CACHE BOOL "Build with ccache support")

# Build to wasm
set(LFORTRAN_BUILD_TO_WASM no
    CACHE BOOL "Compile LFortran To WASM")

if (LFORTRAN_BUILD_TO_WASM)
    set(HAVE_BUILD_TO_WASM yes)
    SET(WITH_WHEREAMI no)
    SET(WITH_ZLIB no)
    SET(WITH_RUNTIME_LIBRARY no)
    SET(WITH_LCOMPILERS_FAST_ALLOC no)
    add_definitions("-DHAVE_BUILD_TO_WASM=1")
endif()

if (WITH_WHEREAMI)
    add_definitions("-DHAVE_WHEREAMI=1")
endif()

if (WITH_ZLIB)
    add_definitions("-DHAVE_ZLIB=1")

    # Find ZLIB with our custom finder before including LLVM since the finder for LLVM
    # might search for ZLIB again and find the shared libraries instead of the static ones
    find_package(StaticZLIB REQUIRED)
endif()

if (WITH_LCOMPILERS_FAST_ALLOC)
    add_definitions("-DLCOMPILERS_FAST_ALLOC=1")
endif()


if (WITH_CCACHE)
    find_program(CCACHE_PROGRAM ccache REQUIRED)
    set(CMAKE_C_COMPILER_LAUNCHER ccache)
    set(CMAKE_CXX_COMPILER_LAUNCHER ccache)
endif()

# LLVM
set(WITH_LLVM no CACHE BOOL "Build with LLVM support")
set(WITH_TARGET_AARCH64 no CACHE BOOL "Enable target AARCH64")
set(WITH_TARGET_X86 no CACHE BOOL "Enable target X86")
set(WITH_TARGET_WASM no CACHE BOOL "Enable target WebAssembly")
set(WITH_MLIR no CACHE BOOL "Build with MLIR support")

# Stacktrace
set(WITH_UNWIND no
    CACHE BOOL "Build with unwind support")
set(WITH_BFD no
    CACHE BOOL "Build with BFD support")
set(WITH_DWARFDUMP no
    CACHE BOOL "Build with dwarfdump support")
set(WITH_LINKH no
    CACHE BOOL "Build with link.h support")
set(WITH_MACHO no
    CACHE BOOL "Build with mach-o support")
set(WITH_STACKTRACE no
    CACHE BOOL "Build with stacktrace support (requires binutils-dev)")
set(WITH_LLVM_STACKTRACE no
    CACHE BOOL "Build with LLVM stacktrace support")
if (WITH_STACKTRACE)
    set(WITH_UNWIND yes)
    if (APPLE)
        set(WITH_MACHO yes)
        if (NOT WITH_BFD)
            set(WITH_DWARFDUMP yes)
        endif()
    else()
        set(WITH_LINKH yes)
        if (NOT WITH_BFD)
            set(WITH_LLVM_STACKTRACE yes)
        endif()
    endif()
    set(HAVE_LFORTRAN_STACKTRACE yes)
endif()
if (WITH_RUNTIME_STACKTRACE)
    set(WITH_UNWIND yes)
    if (APPLE)
        set(WITH_MACHO yes)
    else()
        set(WITH_LINKH yes)
    endif()
    set(HAVE_RUNTIME_STACKTRACE yes)
endif()
if (WITH_BFD)
    find_package(BFD REQUIRED)
    set(HAVE_LFORTRAN_BFD yes)
endif()
if (WITH_LLVM_STACKTRACE)
    set(HAVE_LFORTRAN_LLVM_STACKTRACE yes)
endif()
if (WITH_DWARFDUMP)
    set(HAVE_LFORTRAN_DWARFDUMP yes)
endif()
if (WITH_LINKH)
    find_package(LINKH REQUIRED)
    set(HAVE_LFORTRAN_LINK yes)
endif()
if (WITH_MACHO)
    find_package(MACHO REQUIRED)
    set(HAVE_LFORTRAN_MACHO yes)
endif()
if (WITH_UNWIND)
    set(HAVE_LFORTRAN_UNWIND yes)
endif()

if (WITH_LLVM)
    set(WITH_ZSTD yes CACHE BOOL "Detect (and require) static libzstd for llvm")
    if(WITH_ZSTD)
        find_package(StaticZSTD REQUIRED)
    endif()

    set(LFORTRAN_LLVM_COMPONENTS core support mcjit orcjit native asmparser asmprinter)
    if (WITH_LLVM_STACKTRACE)
        list(APPEND LFORTRAN_LLVM_COMPONENTS symbolize object)
    endif()
    find_package(LLVM REQUIRED)
    message(STATUS "Found LLVM ${LLVM_PACKAGE_VERSION}")
    message(STATUS "Using LLVMConfig.cmake in: ${LLVM_DIR}")

    # LLVM 8 needs the ipo library for PassManagerBuilder
    if (LLVM_VERSION_MAJOR LESS 9)
        list(APPEND LFORTRAN_LLVM_COMPONENTS ipo)
    endif()

    # Always enable the native target
    if ("${LLVM_NATIVE_ARCH}" STREQUAL "AArch64")
        set(WITH_TARGET_AARCH64 yes)
    endif()

    if ("${LLVM_NATIVE_ARCH}" STREQUAL "X86")
        set(WITH_TARGET_X86 yes)
    endif()

    if (WITH_TARGET_AARCH64)
        if (NOT ("${LLVM_TARGETS_TO_BUILD}" MATCHES "AArch64"))
            message(FATAL_ERROR "The selected LLVM library doesn't have support for AArch64 targets")
        endif()

        list(APPEND LFORTRAN_LLVM_COMPONENTS aarch64info aarch64utils aarch64desc aarch64asmparser aarch64codegen aarch64disassembler)
        add_definitions("-DHAVE_TARGET_AARCH64=1")
    endif()

    if (WITH_TARGET_X86)
        if (NOT ("${LLVM_TARGETS_TO_BUILD}" MATCHES "X86"))
            message(FATAL_ERROR "The selected LLVM library doesn't have support for X86 targets")
        endif()

        list(APPEND LFORTRAN_LLVM_COMPONENTS x86info x86desc x86codegen x86asmparser x86disassembler)
        add_definitions("-DHAVE_TARGET_X86=1")
    endif()

    if (WITH_TARGET_WASM)
        if (NOT ("${LLVM_TARGETS_TO_BUILD}" MATCHES "WebAssembly"))
            message(FATAL_ERROR "The selected LLVM library doesn't have support for WebAssembly targets")
        endif()

        list(APPEND LFORTRAN_LLVM_COMPONENTS webassemblyasmparser webassemblycodegen webassemblydesc webassemblydisassembler webassemblyinfo)
        add_definitions("-DHAVE_TARGET_WASM=1")
    endif()

    if (TARGET LLVMCore)
        # If `LLVMCore` target is present, then LLVM is distributed as separate
        # libraries and llvm_map_components_to_libnames() should work:
        llvm_map_components_to_libnames(llvm_libs ${LFORTRAN_LLVM_COMPONENTS})
    else()
        # Workaround for https://github.com/llvm/llvm-project/issues/34593
        # If LLVM is distributed as a single library (the LLVMCore target is
        # missing), we set `llvm_libs` to "LLVM" which links against the single
        # `libLLVM.so` shared library.
        set(llvm_libs "LLVM")
    endif()
    unset(LFORTRAN_LLVM_COMPONENTS)

    if (WITH_MLIR)
        add_library(p::mlir INTERFACE IMPORTED)
        find_package(MLIR REQUIRED CONFIG)
        set(mlir_libs
                MLIRIR
                MLIRLLVMToLLVMIRTranslation
                MLIRBuiltinToLLVMIRTranslation
                MLIRLLVMDialect
                MLIROpenMPToLLVMIRTranslation
                MLIROpenMPDialect
            )
        set_property(TARGET p::mlir PROPERTY INTERFACE_LINK_LIBRARIES ${mlir_libs})
        set(HAVE_LFORTRAN_MLIR yes)
    endif()

    add_library(p::llvm INTERFACE IMPORTED)
    set_property(TARGET p::llvm PROPERTY INTERFACE_INCLUDE_DIRECTORIES
        ${LLVM_INCLUDE_DIRS})
    #set_property(TARGET p::llvm PROPERTY INTERFACE_COMPILE_DEFINITIONS
    #    ${LLVM_DEFINITIONS})
    #set_property(TARGET p::llvm PROPERTY INTERFACE_COMPILE_OPTIONS
    #    ${LLVM_DEFINITIONS})
    set_property(TARGET p::llvm PROPERTY INTERFACE_COMPILE_OPTIONS
        $<$<COMPILE_LANGUAGE:CXX>:${LFORTRAN_CXX_NO_RTTI_FLAG}>)
    set_property(TARGET p::llvm PROPERTY INTERFACE_LINK_LIBRARIES
        ${llvm_libs})
    if (MSVC)
        # LLVM on Windows appends zlib shared library and we must provide
        # a path to find it:
        get_filename_component(mypath ${ZLIB_LIBRARY} DIRECTORY)
        target_link_directories(p::llvm BEFORE INTERFACE ${mypath})
        message(STATUS "ZLIB LIBRARY PATH: ${mypath}")
    endif()
    set(HAVE_LFORTRAN_LLVM yes)
    if(CMAKE_SYSTEM_NAME MATCHES "Linux" AND LLVM_VERSION_MAJOR GREATER_EQUAL 12)
        set(WITH_LIBUNWIND_FORCE yes)
    endif()
endif()

# XEUS (Fortran kernel)
set(WITH_XEUS no CACHE BOOL "Build with XEUS support")
if (WITH_XEUS)
    find_package(xeus 5.1.0 REQUIRED)
    find_package(xeus-zmq 3.0.0 REQUIRED)
    set(HAVE_LFORTRAN_XEUS yes)

    # Generate kernel.json with correct paths
    configure_file (
        "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/fortran/kernel.json.in"
        "${CMAKE_CURRENT_BINARY_DIR}/share/jupyter/kernels/fortran/kernel.json"
    )

    # Generate logo-svg.svg with correct paths
    configure_file (
        "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/fortran/lfortran-logo.svg"
        "${CMAKE_CURRENT_BINARY_DIR}/share/jupyter/kernels/fortran/logo-svg.svg"
    )

    # Configuration and data directories for Jupyter and LFortran
    set(XJUPYTER_DATA_DIR "share/jupyter" CACHE STRING "Jupyter data directory")

    # Install Jupyter kernelspecs
    set(XEUS_CALCSPEC_DIR ${CMAKE_CURRENT_BINARY_DIR}/share/jupyter/kernels)
    install(DIRECTORY ${XEUS_CALCSPEC_DIR}
            DESTINATION ${XJUPYTER_DATA_DIR}
            PATTERN "*.in" EXCLUDE)
endif()

# JSON OR LSP (`conda install rapidjson`)
set(WITH_JSON no CACHE BOOL "Build with JSON support")
set(WITH_LSP no CACHE BOOL "Build with LSP support")
if (WITH_JSON)
    find_package(RapidJSON REQUIRED)
    set(HAVE_LFORTRAN_RAPIDJSON yes)
endif()

set(HAVE_LFORTRAN_DEMANGLE yes

=== integration_tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10 FATAL_ERROR)

project(lfort C Fortran)

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Debug
        CACHE STRING "Build type (Debug, Release)" FORCE)
endif ()

set(LFORTRAN_BACKEND no CACHE STRING "Only compile the LFortran subset for the given backend")
set(FAST no CACHE BOOL "Run supported tests with --fast")
set(NOFAST_LLVM16 no CACHE BOOL "Don't run unsupported tests with --fast when llvm < 17")
set(STD_F23 no CACHE BOOL "Run tests with --std-f23")
set(LLVM_GOC no CACHE BOOL "Run tests with --separate-compilation")

enable_testing()

message("\n")
message("Configuration results")
message("---------------------")
message("Fortran compiler: ${CMAKE_Fortran_COMPILER}")
message("C compiler      : ${CMAKE_C_COMPILER}")
message("Build type: ${CMAKE_BUILD_TYPE}")
string(TOUPPER "${CMAKE_BUILD_TYPE}" BTYPE)
message("Fortran compiler flags: ${CMAKE_Fortran_FLAGS_${BTYPE}}")
message("C compiler flags      : ${CMAKE_C_FLAGS_${BTYPE}}")
message("Installation prefix: ${CMAKE_INSTALL_PREFIX}")
message("LFORTRAN_BACKEND: ${LFORTRAN_BACKEND}")
message("FAST: ${FAST}")
message("NEW_CLASSES: ${NEW_CLASSES}")
message("NOFAST_LLVM16: ${NOFAST_LLVM16}")
message("STD_F23: ${STD_F23}")
message("LLVM_GOC: ${LLVM_GOC}")

macro(RUN_UTIL RUN_FAIL RUN_NAME RUN_FILE_NAME RUN_LABELS RUN_EXTRAFILES RUN_EXTRA_ARGS RUN_COPY_TO_BIN RUN_GFORTRAN_ARGS)
    set(fail ${${RUN_FAIL}})
    set(name ${${RUN_NAME}})
    set(file_name ${${RUN_FILE_NAME}})
    set(labels ${${RUN_LABELS}})
    set(extra_files ${${RUN_EXTRAFILES}})
    set(extra_args ${${RUN_EXTRA_ARGS}})
    set(copy_to_bin ${${RUN_COPY_TO_BIN}})
    set(gfortran_args ${${RUN_GFORTRAN_ARGS}})

    if (NOT name)
        message(FATAL_ERROR "Must specify the NAME argument")
    endif()

    if (LFORTRAN_BACKEND)
        if (${LFORTRAN_BACKEND} IN_LIST labels)
            # Test is supported by the given LFortran backend
            set(ADD_TEST ON)
        else()
            # Test is not supported by the given LFortran backend
            set(ADD_TEST OFF)
        endif()
    else()
        # GFortran
        if ("gfortran" IN_LIST labels)
            set(ADD_TEST ON)
        elseif ("gfortranImplicitArgument" IN_LIST labels)
            set(ADD_TEST ON)
        else()
            set(ADD_TEST OFF)
        endif()
    endif()

    if (ADD_TEST)
        if ((LFORTRAN_BACKEND STREQUAL "cpp") OR (LFORTRAN_BACKEND STREQUAL "x86")
                OR (LFORTRAN_BACKEND STREQUAL "c") OR (LFORTRAN_BACKEND STREQUAL "fortran"))
            add_executable(${name} ${file_name}.f90 ${extra_files})
            target_compile_options(${name} PUBLIC ${extra_args} --backend=${LFORTRAN_BACKEND})
            target_link_options(${name} PUBLIC --backend=${LFORTRAN_BACKEND})
            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
        elseif (LFORTRAN_BACKEND STREQUAL "wasm")
            # wasm test
            execute_process(COMMAND lfortran ${extra_args} --backend=wasm ${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.f90 -o ${name})

            find_program(WASM_EXEC_RUNTIME node)
            execute_process(COMMAND "${WASM_EXEC_RUNTIME}" --version
                            OUTPUT_VARIABLE WASM_EXEC_VERSION
                            OUTPUT_STRIP_TRAILING_WHITESPACE)

            string(REGEX REPLACE "v([0-9]+)\\.([0-9]+)\\.([0-9]+)" "\\1" NODE_MAJOR_VERSION "${WASM_EXEC_VERSION}")

            if (NODE_MAJOR_VERSION LESS 16)
                message(STATUS "${WASM_EXEC_RUNTIME} version: ${WASM_EXEC_VERSION}")
                set(WASM_EXEC_FLAGS "--experimental-wasm-bigint")
            endif()
            set(WASM_EXEC_FLAGS ${WASM_EXEC_FLAGS} "--experimental-wasi-unstable-preview1")
            add_test(${name} ${WASM_EXEC_RUNTIME} ${WASM_EXEC_FLAGS} ${CURRENT_BINARY_DIR}/${name}.js)
        elseif (LFORTRAN_BACKEND STREQUAL "llvm_wasm")
            find_program(WASM_EXEC_RUNTIME wasmtime)
            execute_process(COMMAND "${WASM_EXEC_RUNTIME}" --version
                            OUTPUT_VARIABLE WASM_EXEC_VERSION
                            OUTPUT_STRIP_TRAILING_WHITESPACE)
            add_executable(${name} ${file_name}.f90 ${extra_files})
            target_compile_options(${name} PUBLIC ${extra_args} --backend=llvm --target=wasm32-wasi)
            target_link_options(${name} PUBLIC --backend=llvm --target=wasm32-wasi
                -Wl,-zstack-size=52428800 -Wl,--initial-memory=268435456 -Wl,--max-memory=268435456)
            add_test(${name} ${WASM_EXEC_RUNTIME} ${CURRENT_BINARY_DIR}/${name} --dir=.)
        elseif (LFORTRAN_BACKEND STREQUAL "llvm_wasm_emcc")
            find_program(WASM_EXEC_RUNTIME node)
            execute_process(COMMAND "${WASM_EXEC_RUNTIME}" --version
                            OUTPUT_VARIABLE WASM_EXEC_VERSION
                            OUTPUT_STRIP_TRAILING_WHITESPACE)
            add_executable(${name} ${file_name}.f90 ${extra_files})
            target_compile_options(${name} PUBLIC ${extra_args} --backend=llvm --target=wasm32-unknown-emscripten)
            target_link_options(${name} PUBLIC --backend=llvm --target=wasm32-unknown-emscripten)
            if (copy_to_bin)
                target_link_options(${name} PUBLIC --emcc-embed ${copy_to_bin})
            endif()
            add_test(${name} ${WASM_EXEC_RUNTIME} ${CURRENT_BINARY_DIR}/${name})
        elseif (LFORTRAN_BACKEND STREQUAL "llvm2")
            add_executable(${name} ${file_name}.f90 ${extra_files})
            target_compile_options(${name} PUBLIC --separate-compilation ${extra_args})
            target_link_options(${name} PUBLIC  --separate-compilation ${extra_args})
            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
        elseif (LFORTRAN_BACKEND STREQUAL "llvm_rtlib")
            add_executable(${name} ${file_name}.f90 ${extra_files})
            target_compile_options(${name} PUBLIC --separate-compilation ${extra_args})
            set_source_files_properties(${file_name}.f90 PROPERTIES COMPILE_OPTIONS "--rtlib")
            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
        elseif (LFORTRAN_BACKEND STREQUAL "llvmImplicit")
            execute_process(COMMAND lfortran ${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.f90
                ${extra_args} --implicit-typing --implicit-interface -o ${name})
            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
        elseif (LFORTRAN_BACKEND STREQUAL "llvmStackArray")
            execute_process(COMMAND lfortran ${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.f90
                ${extra_args} --stack-arrays=true -o ${name})
            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
        elseif (LFORTRAN_BACKEND STREQUAL "llvm_nopragma")
            add_executable(${name} ${file_name}.f90 ${extra_files})
            target_compile_options(${name} PUBLIC --ignore-pragma ${extra_args})
            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
        elseif (LFORTRAN_BACKEND STREQUAL "c_nopragma")
            add_executable(${name} ${file_name}.f90 ${extra_files})
            target_compile_options(${name} PUBLIC --backend=c --ignore-pragma ${extra_args})
            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
        elseif (LFORTRAN_BACKEND STREQUAL "llvm")
            add_executable(${name} ${file_name}.f90 ${extra_files})
            target_compile_options(${name} PUBLIC $<$<COMPILE_LANGUAGE:Fortran>:${extra_args}>)
            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
        elseif (LFORTRAN_BACKEND STREQUAL "llvm_omp")
            add_executable(${name} ${file_name}.f90 ${extra_files})
            target_compile_options(${name} PUBLIC --openmp --openmp-lib-dir=$ENV{CONDA_PREFIX}/lib ${extra_args})
            target_link_options(${name} PUBLIC --openmp --openmp-lib-dir=$ENV{CONDA_PREFIX}/lib ${extra_args})
            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
            set_tests_properties(${name} PROPERTIES
                ENVIRONMENT
                    "KMP_TEAMS_THREAD_LIMIT=32"
            )
        elseif (LFORTRAN_BACKEND STREQUAL "target_offload")
            set(c_file "${CURRENT_BINARY_DIR}/${file_name}.c")
            execute_process(
                COMMAND lfortran ${extra_args} --openmp --show-c --target-offload
                        ${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.f90
                OUTPUT_FILE ${c_file}
                RESULT_VARIABLE convert_result
            )
            configure_file(
                ${CMAKE_SOURCE_DIR}/../src/libasr/config.h.in
                ${CMAKE_SOURCE_DIR}/../src/libasr/config.h
                @ONLY
            )
            add_executable(${name}
                ${CMAKE_SOURCE_DIR}/../src/libasr/runtime/lfortran_intrinsics.c
                ${CMAKE_SOURCE_DIR}/../src/libasr/runtime/cuda_cpu_runtime.c
                ${c_file}
            )
            target_include_directories(${name} PUBLIC
                ${CMAKE_SOURCE_DIR}/../src/
                ${CMAKE_SOURCE_DIR}/../src/libasr/runtime
            )
            target_compile_options(${name} PUBLIC -fopenmp)
            target_link_libraries(${name} PUBLIC m)
            target_link_options(${name} PUBLIC -fopenmp)
            target_link_options(${name} PUBLIC -L$ENV{CONDA_PREFIX}/lib ${extra_args})

            add_test(NAME ${name} COMMAND ${name})
        elseif (LFORTRAN_BACKEND STREQUAL "llvm_submodule")
            set(object_files "")
            set(prev_file "")
            foreach(extra_file ${extra_files})
                get_filename_component(obj_name ${extra_file} NAME_WE)
                add_library(${obj_name} OBJECT ${extra_file})
                target_compile_options(${obj_name} PUBLIC $<$<COMPILE_LANGUAGE:Fortran>:${extra_args}>)
                if (prev_file)
                    add_dependencies(${obj_name} ${prev_file})
                endif()
                set(prev_file ${obj_name})
                list(APPEND object_files $<TARGET_OBJECTS:${obj_name}>)
            endforeach()
            add_executable(${name} ${file_name}.f90 ${object_files})
            target_compile_options(${name} PUBLIC $<$<COMPILE_LANGUAGE:Fortran>:${extra_args}>)
            add_dependencies(${name} ${prev_file})
            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
        elseif (LFORTRAN_BACKEND STREQUAL "gfortranModfileCompilation")
            execute_process(COMMAND gfortran ${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.f90 -c)
            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
        elseif (LFORTRAN_BACKEND STREQUAL "mlir")
            execute_process(COMMAND lfortran ${extra_args} --backend=mlir
                ${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.f90 -o ${name})
            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
        elseif (LFORTRAN_BACKEND STREQUAL "mlir_omp")
            execute_process(COMMAND lfortran ${extra_args} --backend=mlir
                --openmp --openmp-lib-dir=$ENV{CONDA_PREFIX}/lib
                --mlir-gpu-offloading
                ${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.f90 -o ${name})
            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
        elseif (LFORTRAN_BACKEND STREQUAL "mlir_llvm_omp")
            execute_process(COMMAND lfortran ${extra_args} --backend=llvm
                --openmp --openmp-lib-dir=$ENV{CONDA_PREFIX}/lib
                --mlir-gpu-offloading
                ${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.f90 -o ${name})
            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
        else ()
            add_executable(${name} ${file_name}.f90 ${extra_files})
            target_compile_options(${name} PUBLIC ${gfortran_args})
            target_link_options(${name} PUBLIC ${gfortran_args})
            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
        endif()

        if (labels)
            set_tests_properties(${name} PROPERTIES LABELS "${labels}")
        endif()

        if (fail)
            set_tests_properties(${name} PROPERTIES WILL_FAIL TRUE)
        endif()

        if (copy_to_bin)

=== debian/changelog ===
lfortran (0.58.0-6) unstable; urgency=medium

  * Update dep on clang to clang-21 for autopkgtests
  * sh m68k x32 also don't have pandoc
  * hurd-amd64 loong64 dont have libunwind-dev
  * Drop ZSTD support that FTBFS on armhf

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 07 Jan 2026 08:35:14 +0000

lfortran (0.58.0-5) unstable; urgency=medium

  * Drop Priority: optional from source in d/control per new policy
  * Standards-Version: 4.7.3
  * Add build-dep on python3 for script
  * d/copyright file fixes for licenserecon -x
  * Pandoc not available on loong64 yet; don't build manpages there

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 06 Jan 2026 16:55:47 +0000

lfortran (0.58.0-4) unstable; urgency=medium

  * Add d/clean so repeated builds work
  * Fix StaticBFD patch

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 23 Dec 2025 06:38:56 +0000

lfortran (0.58.0-3) experimental; urgency=medium

  * Fix UNWIND detection and builds; need to avoid LLVM etc if UNWIND not
    used. This may enable other archs, but may require statically linked
    zstd and zlib. Test in experimental
  * Build-dep on libedit-dev
  * Delete obsolete clang-19.patch
  * lfortran mod compatibility breaks on each release. Change moddir

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 20 Dec 2025 09:18:51 +0000

lfortran (0.58.0-2) unstable; urgency=medium

  * Move to llvm-21
  * Don't use UNWIND on armhf; FTBFS with missing _Unwind_GetIP
  * Include d/salsa-ci.yml

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 19 Dec 2025 08:11:26 +0000

lfortran (0.58.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 16 Dec 2025 13:45:46 +0000

=== debian/control ===
Source: lfortran
Section: devel
Standards-Version: 4.7.3
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends:  debhelper-compat (= 13),
 cmake,
 re2c,
 bison,
 pandoc [!loong64 !sh !m68k !x32],
 python3,
 libfmt-dev,
 libedit-dev,
 libsframe-dev,
 llvm-21-dev [!armhf !hurd-i386 !sparc64 !powerpc !alpha !hppa],
 libunwind-dev [!armhf !hurd-i386 !hurd-amd64 !loong64 !sparc64 !powerpc !alpha !hppa],
 libjsoncpp-dev,
 binutils-dev,
 libiberty-dev,
 libzstd-dev,
 libcurl4-gnutls-dev,
 rapidjson-dev,
 xeus-dev, xeus-zmq-dev,
 zlib1g-dev
Homepage: https://lfortran.org
Vcs-Browser: https://salsa.debian.org/science-team/lfortran
Vcs-Git: https://salsa.debian.org/science-team/lfortran.git

Package: lfortran
Architecture: any
Provides: fortran-compiler, lfortran-mod-0
Built-Using: ${Built-Using}
Depends: ${misc:Depends}, ${shlibs:Depends}, liblfortran-runtime0 ( = ${binary:Version}), 
 clang-21,
 python3:any ,
 liblfortran-dev ( = ${binary:Version}),
Description: Modern interactive LLVM-based Fortran compiler
 LFortran is a modern open-source (BSD licensed) interactive Fortran compiler
 built on top of LLVM. It can execute user’s code interactively to allow 
 exploratory work (much like Python, MATLAB or Julia) as well as compile
 to binaries with the goal to run user’s code on modern architectures such 
 as multi-core CPUs and GPUs.

Package: liblfortran-runtime0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Runtime libraries for the lfortran compiler
 LFortran is a modern open-source (BSD licensed) interactive Fortran compiler
 built on top of LLVM. It can execute user’s code interactively to allow 
 exploratory work (much like Python, MATLAB or Julia) as well as compile
 to binaries with the goal to run user’s code on modern architectures such 
 as multi-core CPUs and GPUs.
 .
 This provides the lfortran runtime libraries.

Package: liblfortran-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, liblfortran-runtime0 (= ${binary:Version})
Description: flang library - Development package.
 LFortran is a modern open-source (BSD licensed) interactive Fortran compiler
 built on top of LLVM. It can execute user’s code interactively to allow 
 exploratory work (much like Python, MATLAB or Julia) as well as compile
 to binaries with the goal to run user’s code on modern architectures such 
 as multi-core CPUs and GPUs.
 .
 This provides the static libraries and development files.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk
BUILDDIR=debian/build

# The magic debhelper  rule
%:
	dh $@ --builddirectory=$(BUILDDIR) --buildsystem=cmake

execute_before_dh_auto_clean:
	rm -fr $(BUILDDIR) version

# -DWITH_XEUS=yes for Jupyter kernel support
# not currently compiling ?

# _Unwind_GetIP missing on armhf
UNWIND:= $(if $(filter $(DEB_TARGET_ARCH), armhf hurd-i386 hurd-amd64 loong64 sparc64 powerpc alpha hppa ),no,yes  )

override_dh_auto_configure:
	echo $(DEB_VERSION_UPSTREAM) > version
	./build0.sh
	mkdir -p $(BUILDDIR)
	dh_auto_configure --  \
		-DCMAKE_BUILD_TYPE=Debug \
		-DWITH_UNWIND=$(UNWIND) \
		-DWITH_RUNTIME_STACKTRACE=$(UNWIND) \
		-DWITH_STACKTRACE=$(UNWIND) \
		-DWITH_LLVM=$(UNWIND) \
		-DWITH_DWARFDUMP=yes  \
		-DWITH_JSON=yes \
		-DWITH_LSP=yes \
		-DWITH_FMT=yes \
		-DWITH_BFD=yes	\
		-DLLVM_DIR=/usr/lib/llvm-21/cmake \
		-DWITH_KOKKOS=yes \
		-DCMAKE_Fortran_MODULE_DIRECTORY=/usr/lib/$(DEB_HOST_MULTIARCH)/fortran/lfortran-mod-$(DEB_VERSION_UPSTREAM)


override_dh_gencontrol:
	dh_gencontrol -- -VBuilt-Using="`dpkg-query -f'$${source:Package} (= $${source:Version}), ' -W binutils-dev libiberty-dev`"

ifneq (,$(filter $(DEB_BUILD_ARCH),loong64 sh m68k x32))
override_dh_installman:
	@echo "Not installing man pages; pandoc missing"
endif

override_dh_auto_test:
	@echo Bypass tests on this build

override_dh_dwz:
	@echo "DWZ fails on .debug_attr sections in some archs; don't use"

## lfortran 0.59.0

=== integration_tests/CMakeLists.txt ===
--- 
+++ 
@@ -137,6 +137,19 @@
             add_executable(${name} ${file_name}.f90 ${extra_files})
             target_compile_options(${name} PUBLIC --backend=c --ignore-pragma ${extra_args})
             add_test(${name} ${CURRENT_BINARY_DIR}/${name})
+        elseif (LFORTRAN_BACKEND STREQUAL "llvm_single_invocation")
+            set(extra_files_full ${extra_files})
+            list(TRANSFORM extra_files_full PREPEND "${CMAKE_CURRENT_SOURCE_DIR}/")
+            add_custom_command(
+                OUTPUT ${CURRENT_BINARY_DIR}/${name}
+                COMMAND lfortran -I${CMAKE_CURRENT_SOURCE_DIR} ${extra_args}
+                    ${extra_files_full} ${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.f90
+                    -o ${CURRENT_BINARY_DIR}/${name}
+                DEPENDS ${extra_files_full} ${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.f90
+                WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+            )
+            add_custom_target(${name}_single_invocation ALL DEPENDS ${CURRENT_BINARY_DIR}/${name})
+            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
         elseif (LFORTRAN_BACKEND STREQUAL "llvm")
             add_executable(${name} ${file_name}.f90 ${extra_files})
             target_compile_options(${name} PUBLIC $<$<COMPILE_LANGUAGE:Fortran>:${extra_args}>)
@@ -209,24 +222,3 @@
                 ${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.f90 -o ${name})
             add_test(${name} ${CURRENT_BINARY_DIR}/${name})
         elseif (LFORTRAN_BACKEND STREQUAL "mlir_llvm_omp")
-            execute_process(COMMAND lfortran ${extra_args} --backend=llvm
-                --openmp --openmp-lib-dir=$ENV{CONDA_PREFIX}/lib
-                --mlir-gpu-offloading
-                ${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.f90 -o ${name})
-            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
-        else ()
-            add_executable(${name} ${file_name}.f90 ${extra_files})
-            target_compile_options(${name} PUBLIC ${gfortran_args})
-            target_link_options(${name} PUBLIC ${gfortran_args})
-            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
-        endif()
-
-        if (labels)
-            set_tests_properties(${name} PROPERTIES LABELS "${labels}")
-        endif()
-
-        if (fail)
-            set_tests_properties(${name} PROPERTIES WILL_FAIL TRUE)
-        endif()
-
-        if (copy_to_bin)

=== src/lfortran/tests/CMakeLists.txt ===
project(tests)

macro(ADDTEST name)
    add_executable(${name} ${name}.cpp)
    target_link_libraries(${name} lfortran_lib  ${ARGN})
    add_test(${name} ${PROJECT_BINARY_DIR}/${name})
endmacro(ADDTEST)

macro(ADDTESTC name)
    add_executable(${name} ${name}.c)
    # Link only to specified libraries, not lfortran_lib which brings in C++
    # flags from xeus-zmq that are invalid for C compilation (-Wreorder)
    target_link_libraries(${name} ${ARGN})
    add_test(${name} ${PROJECT_BINARY_DIR}/${name})
endmacro(ADDTESTC)

ADDTESTC(test_cwrapper lfortran_c)
ADDTEST(test_stacktrace)

set(SRC
    test_parse.cpp
    test_ast.cpp
    test_stacktrace2.cpp
    test_asm.cpp
    test_serialization.cpp
    test_pickle.cpp
    test_error_rendering.cpp
)

if (WITH_JSON)
    set(SRC ${SRC}
        test_ast_to_json.cpp
    )
endif()
if (WITH_LLVM)
    set(SRC ${SRC}
        test_llvm.cpp
    )
endif()

if (WITH_LSP)
    set(SRC_AST ${SRC_AST}
        test_ast.cpp
    )
endif()


# Add one main test suite for LFortran, composed of many individual cpp files:
add_executable(test_lfortran ${SRC})
target_link_libraries(test_lfortran lfortran_lib p::doctest)
target_compile_definitions(test_lfortran PRIVATE LFORTRAN_PROJECT_SOURCE_DIR="${CMAKE_SOURCE_DIR}")
if (HAVE_BUILD_TO_WASM)
    set(WASM_COMPILE_FLAGS "-g0 -fexceptions")
    set(WASM_LINK_FLAGS
      "-Oz -g0 -fexceptions -Wall -Wextra -s ASSERTIONS -s ALLOW_MEMORY_GROWTH=1 -s WASM_BIGINT"
    )
    set_target_properties(test_lfortran PROPERTIES COMPILE_FLAGS ${WASM_COMPILE_FLAGS})
    set_target_properties(test_lfortran PROPERTIES LINK_FLAGS ${WASM_LINK_FLAGS})
endif()
add_test(test_lfortran ${PROJECT_BINARY_DIR}/test_lfortran)

if (WITH_LLVM)
    if (CMAKE_SYSTEM_NAME STREQUAL "Linux"
        OR CMAKE_SYSTEM_NAME STREQUAL "FreeBSD"
        OR CMAKE_SYSTEM_NAME STREQUAL "OpenBSD")

        target_link_options(test_lfortran PRIVATE "LINKER:--export-dynamic")
    endif()
endif()

if (WITH_LSP)
    add_executable(test_asr ${SRC_AST})
    target_link_libraries(test_asr lfortran_lib p::doctest)
    add_test(test_asr ${PROJECT_BINARY_DIR}/test_asr)
    if (CMAKE_SYSTEM_NAME STREQUAL "Linux"
        OR CMAKE_SYSTEM_NAME STREQUAL "FreeBSD"
        OR CMAKE_SYSTEM_NAME STREQUAL "OpenBSD")
        target_link_options(test_asr PRIVATE "LINKER:--export-dynamic")
    endif()
endif()

=== debian/changelog ===
lfortran (0.59.0-3) unstable; urgency=medium

  * Fix missing d/copyright line
  * Fix d/rules: dont use llvm/unwind on loong64

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 01 Feb 2026 09:14:50 +0000

lfortran (0.59.0-2) unstable; urgency=medium

  * Unwind-dev missing on loong64 too
  * Also don't build man pages on hurd-i386 hurd-amd64 sh4 x32 m68k; no
    pandoc available
  * d/gpb.conf: pristine-tar = True
  * Set module dir to lfortran-mod-0
  * zstd.patch: ensure zstd used at all times. Fixes FTBFS on  armhf

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 31 Jan 2026 12:11:29 +0000

lfortran (0.59.0-1) unstable; urgency=medium

  * Add d/watch file
  * New upstream release
  * Update static-bfd.patch
  * liblfortran_c.patch: fix linking bfd
  * Fix to d/copyright license name
  * Re-include hard-coded clang-* path

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 30 Jan 2026 16:25:02 +0000

=== debian/control ===
--- 
+++ 
@@ -7,13 +7,13 @@
  cmake,
  re2c,
  bison,
- pandoc [!loong64 !sh !m68k !x32],
+ pandoc [!loong64 !hurd-i386 !hurd-amd64 !sh4 !x32 !m68k],
  python3,
  libfmt-dev,
  libedit-dev,
  libsframe-dev,
- llvm-21-dev [!armhf !hurd-i386 !sparc64 !powerpc !alpha !hppa],
- libunwind-dev [!armhf !hurd-i386 !hurd-amd64 !loong64 !sparc64 !powerpc !alpha !hppa],
+ llvm-21-dev [!armhf !hurd-i386 !sparc64 !powerpc !alpha !hppa !loong64],
+ libunwind-dev [!armhf !hurd-i386 !sparc64 !powerpc !alpha !hppa !loong64],
  libjsoncpp-dev,
  binutils-dev,
  libiberty-dev,
@@ -24,7 +24,7 @@
  zlib1g-dev
 Homepage: https://lfortran.org
 Vcs-Browser: https://salsa.debian.org/science-team/lfortran
-Vcs-Git: https://salsa.debian.org/science-team/lfortran.git
+Vcs-Git: https://salsa.debian.org/science-team/lfortran.git -b debian/latest
 
 Package: lfortran
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -17,7 +17,7 @@
 # not currently compiling ?
 
 # _Unwind_GetIP missing on armhf
-UNWIND:= $(if $(filter $(DEB_TARGET_ARCH), armhf hurd-i386 hurd-amd64 loong64 sparc64 powerpc alpha hppa ),no,yes  )
+UNWIND:= $(if $(filter $(DEB_TARGET_ARCH), armhf hurd-i386 sparc64 powerpc alpha hppa loong64 ),no,yes  )
 
 override_dh_auto_configure:
 	echo $(DEB_VERSION_UPSTREAM) > version
@@ -36,13 +36,13 @@
 		-DWITH_BFD=yes	\
 		-DLLVM_DIR=/usr/lib/llvm-21/cmake \
 		-DWITH_KOKKOS=yes \
-		-DCMAKE_Fortran_MODULE_DIRECTORY=/usr/lib/$(DEB_HOST_MULTIARCH)/fortran/lfortran-mod-$(DEB_VERSION_UPSTREAM)
+		-DCMAKE_Fortran_MODULE_DIRECTORY=/usr/lib/$(DEB_HOST_MULTIARCH)/fortran/lfortran-mod-0
 
 
 override_dh_gencontrol:
 	dh_gencontrol -- -VBuilt-Using="`dpkg-query -f'$${source:Package} (= $${source:Version}), ' -W binutils-dev libiberty-dev`"
 
-ifneq (,$(filter $(DEB_BUILD_ARCH),loong64 sh m68k x32))
+ifneq (,$(filter $(DEB_BUILD_ARCH),loong64 hurd-i386 hurd-amd64 sh4 x32 m68k ))
 override_dh_installman:
 	@echo "Not installing man pages; pandoc missing"
 endif

=== debian/watch ===
Version: 5
Template: GitHub
Dist: https://github.com/lfortran/lfortran

## lfortran 0.60.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -132,7 +132,8 @@
 
     # Find ZLIB with our custom finder before including LLVM since the finder for LLVM
     # might search for ZLIB again and find the shared libraries instead of the static ones
-    find_package(StaticZLIB REQUIRED)
+    set(USE_DYNAMIC_ZLIB no CACHE BOOL "Use dynamic ZLIB library (default: static)")
+    find_package(LFortranZLIB REQUIRED)
 endif()
 
 if (WITH_LCOMPILERS_FAST_ALLOC)
@@ -215,9 +216,10 @@
 endif()
 
 if (WITH_LLVM)
-    set(WITH_ZSTD yes CACHE BOOL "Detect (and require) static libzstd for llvm")
+    set(WITH_ZSTD yes CACHE BOOL "Detect (and require) libzstd for LLVM")
+    set(USE_DYNAMIC_ZSTD no CACHE BOOL "Use dynamic ZSTD library (default: static)")
     if(WITH_ZSTD)
-        find_package(StaticZSTD REQUIRED)
+        find_package(LFortranZSTD REQUIRED)
     endif()
 
     set(LFORTRAN_LLVM_COMPONENTS core support mcjit orcjit native asmparser asmprinter)
@@ -352,10 +354,3 @@
 
 # JSON OR LSP (`conda install rapidjson`)
 set(WITH_JSON no CACHE BOOL "Build with JSON support")
-set(WITH_LSP no CACHE BOOL "Build with LSP support")
-if (WITH_JSON)
-    find_package(RapidJSON REQUIRED)
-    set(HAVE_LFORTRAN_RAPIDJSON yes)
-endif()
-
-set(HAVE_LFORTRAN_DEMANGLE yes

=== integration_tests/CMakeLists.txt ===
--- 
+++ 
@@ -129,6 +129,10 @@
             execute_process(COMMAND lfortran ${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.f90
                 ${extra_args} --stack-arrays=true -o ${name})
             add_test(${name} ${CURRENT_BINARY_DIR}/${name})
+        elseif (LFORTRAN_BACKEND STREQUAL "llvm_integer_8")
+            execute_process(COMMAND lfortran ${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.f90
+                ${extra_args} -fdefault-integer-8 -o ${name})
+            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
         elseif (LFORTRAN_BACKEND STREQUAL "llvm_nopragma")
             add_executable(${name} ${file_name}.f90 ${extra_files})
             target_compile_options(${name} PUBLIC --ignore-pragma ${extra_args})
@@ -218,7 +222,3 @@
         elseif (LFORTRAN_BACKEND STREQUAL "mlir_omp")
             execute_process(COMMAND lfortran ${extra_args} --backend=mlir
                 --openmp --openmp-lib-dir=$ENV{CONDA_PREFIX}/lib
-                --mlir-gpu-offloading
-                ${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.f90 -o ${name})
-            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
-        elseif (LFORTRAN_BACKEND STREQUAL "mlir_llvm_omp")

=== src/runtime/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10 FATAL_ERROR)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

project(lfortran_unif_runtime C Fortran)

set(LFORTRAN_NESTED_BUILD no
    CACHE BOOL "Whether we are being called from the LFortran build system")

if(NOT LFORTRAN_NESTED_BUILD)
    add_subdirectory(legacy)
endif()

# See the TODO in the installation step below
set(CMAKE_Fortran_MODULE_DIRECTORY ${CMAKE_BINARY_DIR})
include_directories(${CMAKE_Fortran_MODULE_DIRECTORY})

set(LFORTRAN_COMPILER_STAMP "${CMAKE_BINARY_DIR}/lfortran_compiler.stamp")
add_custom_command(
  OUTPUT "${LFORTRAN_COMPILER_STAMP}"
  COMMAND "${CMAKE_COMMAND}" -E touch "${LFORTRAN_COMPILER_STAMP}"
  DEPENDS "${CMAKE_Fortran_COMPILER}"
  VERBATIM
  )

macro(lfortran_compile_runtime name dir)
  set_source_files_properties(
    ${dir}/${name}.f90
    PROPERTIES
    OBJECT_DEPENDS "${LFORTRAN_COMPILER_STAMP}"
    )
  add_library(${name} OBJECT ${dir}/${name}.f90)
  target_compile_options(${name} PUBLIC "--backend=cpp")
  set_target_properties(${name} PROPERTIES
    POSITION_INDEPENDENT_CODE False
    Fortran_PREPROCESS False)

  if(ARGN)
    add_dependencies(${name} ${ARGN})
  endif()
endmacro(lfortran_compile_runtime)

lfortran_compile_runtime(lfortran_intrinsic_iso_fortran_env pure)

lfortran_compile_runtime(lfortran_intrinsic_custom custom)

lfortran_compile_runtime(lfortran_intrinsic_ieee_arithmetic pure)
add_dependencies(lfortran_intrinsic_ieee_arithmetic lfortran_intrinsic_iso_fortran_env)

lfortran_compile_runtime(lfortran_intrinsic_iso_c_binding pure)

lfortran_compile_runtime(omp_lib openmp)
add_dependencies(omp_lib lfortran_intrinsic_iso_c_binding)

# Ideally this should be a target based install, not file based:
# install(DIRECTORY ${CMAKE_Fortran_MODULE_DIRECTORY}/ DESTINATION ${CMAKE_INSTALL_LIBDIR})
# but for historical reasons get_runtime_library_dir() looks under "/../../runtime"
# during tests.
# TODO: Change get_runtime_library_dir() to "/../../modfiles" for tests
install(
  FILES
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_custom.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_iso_fortran_env.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_ieee_arithmetic.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_iso_c_binding.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/omp_lib.mod
  DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )

=== debian/changelog ===
lfortran (0.60.0-1) unstable; urgency=medium

  * llvm/unwind also unavailable on x32,m68k,sh4 archs
  * New upstream release
  * d/gbp.conf: Revert upstream branch to 'upstream'
  * Drop / from paths in install files

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 08 Feb 2026 17:01:50 +0000

=== debian/control ===
--- 
+++ 
@@ -12,8 +12,8 @@
  libfmt-dev,
  libedit-dev,
  libsframe-dev,
- llvm-21-dev [!armhf !hurd-i386 !sparc64 !powerpc !alpha !hppa !loong64],
- libunwind-dev [!armhf !hurd-i386 !sparc64 !powerpc !alpha !hppa !loong64],
+ llvm-21-dev [!armhf !hurd-i386 !sparc64 !powerpc !alpha !hppa !loong64 !m68k !sh4 !x32],
+ libunwind-dev [!armhf !hurd-i386 !sparc64 !powerpc !alpha !hppa !loong64 !m68k !sh4 !x32],
  libjsoncpp-dev,
  binutils-dev,
  libiberty-dev,

=== debian/rules ===
--- 
+++ 
@@ -17,7 +17,7 @@
 # not currently compiling ?
 
 # _Unwind_GetIP missing on armhf
-UNWIND:= $(if $(filter $(DEB_TARGET_ARCH), armhf hurd-i386 sparc64 powerpc alpha hppa loong64 ),no,yes  )
+UNWIND:= $(if $(filter $(DEB_TARGET_ARCH), armhf hurd-i386 sparc64 powerpc alpha hppa loong64 m68k sh4 x32 ),no,yes  )
 
 override_dh_auto_configure:
 	echo $(DEB_VERSION_UPSTREAM) > version
